c +++++ Quasi-Free Hyperon Productions ++++++++++++++++++++++++++++++++
c ... common /RIDS/ reaction ID
c
c All		All with KN	  	:  - (with KN)	p1 : black
c KN		KN reaction  	:  1 (formation)	p1 : black
c tnL		none-mesic Lmbda	:  2 (reaction)	p1 : yellow
c tnS		none-mesic Sigma	:  3 (reaction)	p1 : blue
c pi_abs	pion absorption	:  4 (internal)	p1 : cyan
c SLC		Sigma-Lmbda conv 	:  5 (reaction)	p1 : green
c QFL		QF (mesic) Lmbda	:  6 (reaction)	p1 : magenta
c QFS		QF (mesic) Sigma	:  7 (reaction)	p1 : red
c CBG		const. background	:  8 (accidental)	p1 : blue
c
c -All	All without KN  	:  - (without KN)	p2 : black
c -KN		KN reaction		: -1 (KN decay)	p2 : black
c -tnL	none-mesic Lmbda	: -2 (L decay)	p2 : yellow
c -tnS	none-mesic Sigma	: -3 (S decay)	p2 : blue
c -pI_abs	pion absorption	: -4 (external)	p2 : cyan
c -SLC	igma-Lmbda conv	: -5 (L decay)	p2 : green
c -QFL	QF (mesic) Lmbda	: -6 (L decay)	p2 : magenta
c -QFS	QF (mesic) Sigma	: -7 (S decay)	p2 : red
c -pI_mono	pion abs mono	: -8 (external)	p2 : blue
c



      subroutine Quasi_Free_Process
      implicit NONE
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c local
	real r
c external
      real rn
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c begin
c>	if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*)  'QF-branch', p_quasi
      r = rn()
c 1: S+ pi- 0.324
      if( r .lt. p_quasi(1) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'Sp_pim'
         call Sp_pim
c 2: S- pi+ 0.109
      else if( r .lt. p_quasi(2) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'Sm_pip'
         call Sm_pip
c 3: S0 pi0 0.183
      else if( r .lt. p_quasi(3) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'S0_pi0'
         call S0_pi0
c 4: Sm pi0 0.067
      else if( r .lt. p_quasi(4) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'Sm_pi0'
         call Sm_pi0
c 5: S0 pi- 0.067
      else if( r .lt. p_quasi(5) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'S0_pim'
         call S0_pim
c 6: L  pi0 0.083
      else if( r .lt. p_quasi(6) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'L_pi0'
         call L_pi0
c 7: L  pi- 0.167
      else if( r .lt. p_quasi(7) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'L_pim'
         call L_pim
c 8: S+  pi0 0.03
	else 
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'Sp_pi0'
         call Sp_pi0
      endif
c>	if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'Quasi_Free_Process end'
c>	if(debug_F .and. (ev_NUM .ge. ev_error))stop
      return
      end




      subroutine Sp_pim
      implicit NONE
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c constant
	integer reactionID / 1 /
c local 
      real point(3), time
      real p_Sp, v_Sp(3), p_pi, v_pi(3), p_triton, v_triton(3)
      real p_deuteron, v_deuteron(3), p_n, v_n(3)
      integer N_nucl, N_pickup, N_num, iflag
c exernal
	real rn
c begin
c 1 Sigma+ pi- quasi-free production (first step)
      time = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
c 
      N_nucl = 4
      iflag = 0
c ... He4 K-  ->  S+ pi- t   (1N-induced) 
	if(rn() .lt. r_1N_2N_S) then
         N_num = 3
         N_pickup = 1
         call reaction_at_rest_3( M_helium4, M_k,
     &            M_Sp, M_pi, M_triton,
     &            p_Sp, p_pi, p_triton, 
     &            v_Sp, v_pi, v_triton, N_nucl, N_pickup, iflag )
c ... He4 K-  ->  S+ pi- n d   (2N-induced)
      else
         N_num = 2
         N_pickup = 2
         call reaction_at_rest_4( M_helium4, M_k, 
     &            M_Sp, M_pi, M_n, M_deuteron,
     &            p_Sp, p_pi, p_n, p_deuteron, 
     &            v_Sp, v_pi, v_n, v_deuteron, N_nucl, N_pickup, iflag )
      endif
c ... SL conversion
	if( rn() .lt. p_SL_conv(reactionID) ) then
         call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
	   if( N_num .eq. 3) then
		call triton_SL_conversion(M_triton, p_triton, v_triton,
     &		M_Sp, p_Sp, v_Sp, r_1N_2N_SLC, point, time, SLC)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call deuteron_SL_conversion(M_deuteron, p_deuteron, v_deuteron,
     &		M_Sp, p_Sp, v_Sp, r_1N_2N_SLC, point, time, SLC)
	   endif
	   return
	endif
c ... YN scattering
	if( rn() .lt. p_Y_scat(reactionID) ) then
         call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_scattering(
     &		PID_triton, M_triton, p_triton, v_triton,
     &		PID_SigmaP, M_Sp, p_Sp, v_Sp, r_1N_2N_SNS, point, time, QFS)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_SigmaP, M_Sp, p_Sp, v_Sp, r_1N_2N_SNS, point, time, QFS)
	   endif
	   return
	endif
c ... piN scattering
	if( rn() .lt. p_pi_scat(reactionID) ) then
         call put_stack(PID_SigmaP, p_Sp, v_Sp, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_scattering(
     &		PID_triton, M_triton, p_triton, v_triton,
     &		-PID_pion, M_pi, p_pi, v_pi, r_1N_2N_piS, point, time, QFS)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		-PID_pion, M_pi, p_pi, v_pi, r_1N_2N_piS, point, time, QFS)
	   endif
	   return
	endif
c ... pi absorption
	if( rn() .lt. p_pi_abs(reactionID) ) then
         call put_stack(PID_SigmaP, p_Sp, v_Sp, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_pion_absorption(M_triton, p_triton, v_triton,
     &		-PID_pion, M_pi, p_pi, v_pi, point, time, pi_abs)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_pion_absorption(M_deuteron, p_deuteron, v_deuteron,
     &		-PID_pion, M_pi, p_pi, v_pi, point, time, pi_abs)
	   endif
	   return
	endif
c ... without 2ndary reaction
      call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
      call put_stack(PID_SigmaP, p_Sp, v_Sp, point, time, QFS)
	if( N_num .eq. 3) then
         call put_stack(PID_triton, p_triton, v_triton, point, time, QFS)
	else
         call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFS)
         call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
	endif
	return
	end




      subroutine Sp_pi0
      implicit NONE
c common
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c external
	real rn
c local 
      real p_Sp, v_Sp(3), p_pi, v_pi(3), p_triton, v_triton(3)
      real point(3), time, p_deuteron, v_deuteron(3) 
      real p_n1, v_n1(3), p_pi0, v_pi0(3)
      real p_n, v_n(3), p_n2, v_n2(3)
      integer N_nucl, N_pickup, N_num, iflag
c constant
	integer reactionID / 8 /
c begin
c 8 Sigma+ pi0 quasi-free production (first step)
      time = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
c 
      N_nucl = 4
      iflag = 0
c S+ pi0 n n n
c this reaction cannot happen with one step. 
c produce pi- first, and then charge exchnge to pi0
c ... He4 K-  ->  S+ pi- t   (2N-induced) 
	if(rn() .lt. r_1N_2N_S) then
         N_num = 3
         N_pickup = 1
         call reaction_at_rest_3( M_helium4, M_k,
     &            M_Sp, M_pi, M_triton,
     &            p_Sp, p_pi, p_triton, 
     &            v_Sp, v_pi, v_triton, N_nucl, N_pickup, iflag )
c ... He4 K-  ->  S+ pi- n d   (2N-induced)
      else
         N_num = 2
         N_pickup = 2
         call reaction_at_rest_4( M_helium4, M_k, 
     &            M_Sp, M_pi, M_n, M_deuteron,
     &            p_Sp, p_pi, p_n, p_deuteron, 
     &            v_Sp, v_pi, v_n, v_deuteron, N_nucl, N_pickup, iflag )
      endif
c ... piN scattering
      iflag = -1
      call put_stack(PID_SigmaP, p_Sp, v_Sp, point, time, QFS)
	if( N_num .eq. 3) then
            N_nucl = 3
            N_pickup = 1
            call breakup_in_flight_4(
     &            M_triton, p_triton, v_triton, M_pi, p_pi, v_pi,
     &            M_n,  M_pi0, M_n,  M_n,  
     &            p_n,  p_pi0, p_n1, p_n2,
     &            v_n,  v_pi0, v_n1, v_n2, N_nucl, N_pickup, iflag )
		if( iflag .eq. 0) then
               call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
               call put_stack(PID_neutron, p_n1, v_n1, point, time, QFS)
               call put_stack(PID_neutron, p_n2, v_n2, point, time, QFS)
               call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFS)
		else
               call put_stack(PID_triton, p_triton, v_triton, point, time, QFS)
               call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
		endif
	else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
            N_nucl = 2
            N_pickup = 1
            call reaction_in_flight_3(
     &            M_deuteron, p_deuteron, v_deuteron, M_pi, p_pi, v_pi,
     &            M_n,  M_pi0, M_n,  
     &            p_n2,  p_pi0, p_n1, 
     &            v_n2,  v_pi0, v_n1, N_nucl, N_pickup, iflag )
		if( iflag .eq. 0) then
               call put_stack(PID_neutron, p_n1, v_n1, point, time, QFS)
               call put_stack(PID_neutron, p_n2, v_n2, point, time, QFS)
               call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFS)
		else
               call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFS)
               call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
		endif
	endif
	return
	end




      subroutine Sm_pip
      implicit NONE
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c external
	real rn
c local 
      real p_Sm, v_Sm(3), p_pi, v_pi(3), p_triton, v_triton(3)
      real point(3), time, p_deuteron, v_deuteron(3) 
      real p_n, v_n(3)
      integer N_nucl, N_pickup, N_num, iflag
c constant
	integer reactionID / 2 /
c begin
c 2 Sigma- pi+ quasi-free production (first step)
      time = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
c 
      N_nucl = 4
      iflag = 0
c ... He4 K-  ->  S- pi+ t   (1N-induced) 
	if(rn() .lt. r_1N_2N_S) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'S- pi+ t '
         N_num = 3
         N_pickup = 1
         call reaction_at_rest_3( M_helium4, M_k,
     &            M_Sm, M_pi, M_triton,
     &            p_Sm, p_pi, p_triton, 
     &            v_Sm, v_pi, v_triton, N_nucl, N_pickup, iflag )
c ... He4 K-  ->  S- pi+ n d   (2N-induced)
      else
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'S- pi+ n d'
         N_num = 2
         N_pickup = 2
         call reaction_at_rest_4( M_helium4, M_k, 
     &            M_Sm, M_pi, M_n, M_deuteron,
     &            p_Sm, p_pi, p_n, p_deuteron, 
     &            v_Sm, v_pi, v_n, v_deuteron, N_nucl, N_pickup, iflag )
      endif
c ... SL conversion
	if( rn() .lt. p_SL_conv(reactionID) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) ' -- SL conv'
         call put_stack(PID_pion, p_pi, v_pi, point, time, QFS)
	   if( N_num .eq. 3) then
		call triton_SL_conversion(M_triton, p_triton, v_triton,
     &		M_Sm, p_Sm, v_Sm, r_1N_2N_SLC, point, time, SLC)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call deuteron_SL_conversion(M_deuteron, p_deuteron, v_deuteron,
     &		M_Sm, p_Sm, v_Sm, r_1N_2N_SLC, point, time, SLC)
	   endif
	   return
	endif
c ... YN scattering
	if( rn() .lt. p_Y_scat(reactionID) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) ' -- YN scat'
         call put_stack(PID_pion, p_pi, v_pi, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_scattering(
     &		PID_triton, M_triton, p_triton, v_triton,
     &		PID_SigmaM, M_Sm, p_Sm, v_Sm, r_1N_2N_SNS, point, time, QFS)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_SigmaM, M_Sm, p_Sm, v_Sm, r_1N_2N_SNS, point, time, QFS)
	   endif
	   return
	endif
c ... piN scattering
	if( rn() .lt. p_pi_scat(reactionID) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) ' -- piN scat'
         call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_scattering(
     &		PID_triton, M_triton, p_triton, v_triton,
     &		PID_pion, M_pi, p_pi, v_pi, r_1N_2N_piS, point, time, QFS)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_pion, M_pi, p_pi, v_pi, r_1N_2N_piS, point, time, QFS)
	   endif
	   return
	endif
c ... pi absorption
	if( rn() .lt. p_pi_abs(reactionID) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) ' -- pi abs'
         call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_pion_absorption(M_triton, p_triton, v_triton,
     &		PID_pion, M_pi, p_pi, v_pi, point, time, pi_abs)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_pion_absorption(M_deuteron, p_deuteron, v_deuteron,
     &		PID_pion, M_pi, p_pi, v_pi, point, time, pi_abs)
	   endif
	   return
	endif
c ... without 2ndary reaction
c>	if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) ' -- without 2nd'
      call put_stack(PID_pion, p_pi, v_pi, point, time, QFS)
      call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, QFS)
	if( N_num .eq. 3) then
         call put_stack(PID_triton, p_triton, v_triton, point, time, QFS)
	else
         call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
         call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFS)
	endif
	return
	end




      subroutine S0_pi0
      implicit NONE
c common
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c external 
	real rn
c local 
      real p_S0, v_S0(3), p_pi0, v_pi0(3), p_triton, v_triton(3)
      real point(3), time, p_deuteron, v_deuteron(3) 
      real p_n, v_n(3)
      integer N_nucl, N_pickup, N_num, iflag
c constant
	integer reactionID / 3 /
c begin
c 3 Sigma0 pi0 quasi-free production (first step)
      time = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
c 
      N_nucl = 4
      iflag = 0
c ... He4 K-  ->  S0 pi0 t   (1N-induced) 
	if(rn() .lt. r_1N_2N_S) then
         N_num = 3
         N_pickup = 1
         call reaction_at_rest_3( M_helium4, M_k,
     &            M_S0, M_pi0, M_triton,
     &            p_S0, p_pi0, p_triton, 
     &            v_S0, v_pi0, v_triton, N_nucl, N_pickup, iflag )
c ... He4 K-  ->  S0 pi0 n d   (2N-induced)
      else
         N_num = 2
         N_pickup = 2
         call reaction_at_rest_4( M_helium4, M_k, 
     &            M_S0, M_pi0, M_n, M_deuteron,
     &            p_S0, p_pi0, p_n, p_deuteron, 
     &            v_S0, v_pi0, v_n, v_deuteron, N_nucl, N_pickup, iflag )
      endif
c ... SL conversion
	if( rn() .lt. p_SL_conv(reactionID) ) then
         call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFS)
	   if( N_num .eq. 3) then
		call triton_SL_conversion(M_triton, p_triton, v_triton,
     &		M_S0, p_S0, v_S0, r_1N_2N_SLC, point, time, SLC)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call deuteron_SL_conversion(M_deuteron, p_deuteron, v_deuteron,
     &		M_S0, p_S0, v_S0, r_1N_2N_SLC, point, time, SLC)
	   endif
	   return
	endif
c ... YN scattering
	if( rn() .lt. p_Y_scat(reactionID) ) then
         call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_scattering(
     &		PID_triton, M_triton, p_triton, v_triton,
     &		PID_Sigma0, M_S0, p_S0, v_S0, r_1N_2N_SNS, point, time, QFS)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_Sigma0, M_S0, p_S0, v_S0, r_1N_2N_SNS, point, time, QFS)
	   endif
	   return
	endif
c ... piN scattering
	if( rn() .lt. p_pi_scat(reactionID) ) then
         call put_stack(PID_Sigma0, p_S0, v_S0, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_scattering(
     &		PID_triton, M_triton, p_triton, v_triton,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, r_1N_2N_piS, point, time, QFS)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, r_1N_2N_piS, point, time, QFS)
	   endif
	   return
	endif
c ... pi absorption
	if( rn() .lt. p_pi_abs(reactionID) ) then
         call put_stack(PID_Sigma0, p_S0, v_S0, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_triton_pion_absorption(M_triton, p_triton, v_triton,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, point, time, pi_abs)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
		call internal_deuteron_pion_absorption(M_deuteron, p_deuteron, v_deuteron,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, point, time, pi_abs)
	   endif
	   return
	endif
c ... without 2ndary reaction
      call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFS)
      call put_stack(PID_Sigma0, p_S0, v_S0, point, time, QFS)
	if( N_num .eq. 3) then
         call put_stack(PID_triton, p_triton, v_triton, point, time, QFS)
	else
         call put_stack(PID_neutron, p_n, v_n, point, time, QFS)
         call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFS)
	endif
	return
	end




      subroutine Sm_pi0
      implicit NONE
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c external
	real rn
c local 
      real p_Sm, v_Sm(3), p_pi0, v_pi0(3), p_helium3, v_helium3(3)
      real point(3), time, p_deuteron, v_deuteron(3) 
      real p_p, v_p(3)
      integer N_nucl, N_pickup, N_num, iflag
c ... constant
	integer reactionID / 4 /
c begin
c 4 Sigma- pi0 quasi-free production (first step)
      time = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
c
      N_nucl = 4
      iflag = 0
c ... He4 K-  ->  S- pi0 He3   (1N-induced) 
	if(rn() .lt. r_1N_2N_S) then
         N_num = 3
         N_pickup = 1
         call reaction_at_rest_3( M_helium4, M_k,
     &            M_Sm, M_pi0, M_helium3,
     &            p_Sm, p_pi0, p_helium3, 
     &            v_Sm, v_pi0, v_helium3, N_nucl, N_pickup, iflag )
c ... He4 K-  ->  S- pi0 p d   (2N-induced)
      else
         N_num = 2
         N_pickup = 2
         call reaction_at_rest_4( M_helium4, M_k, 
     &            M_Sm, M_pi0, M_p, M_deuteron,
     &            p_Sm, p_pi0, p_p, p_deuteron, 
     &            v_Sm, v_pi0, v_p, v_deuteron, N_nucl, N_pickup, iflag )
      endif
c ... SL conversion
	if( rn() .lt. p_SL_conv(reactionID) ) then
         call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFS)
	   if( N_num .eq. 3) then
		call helium3_SL_conversion(M_helium3, p_helium3, v_helium3,
     &		M_Sm, p_Sm, v_Sm, r_1N_2N_SLC, point, time, SLC)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFS)
		call deuteron_SL_conversion(M_deuteron, p_deuteron, v_deuteron,
     &		M_Sm, p_Sm, v_Sm, r_1N_2N_SLC, point, time, SLC)
	   endif
	   return
	endif
c ... YN scattering
	if( rn() .lt. p_Y_scat(reactionID) ) then
         call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_helium3_scattering(
     &		PID_helium3, M_helium3, p_helium3, v_helium3,
     &		PID_SigmaM, M_Sm, p_Sm, v_Sm, r_1N_2N_SNS, point, time, QFS)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_SigmaM, M_Sm, p_Sm, v_Sm, r_1N_2N_SNS, point, time, QFS)
	   endif
	   return
	endif
c ... piN scattering
	if( rn() .lt. p_pi_scat(reactionID) ) then
         call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_helium3_scattering(
     &		PID_helium3, M_helium3, p_helium3, v_helium3,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, r_1N_2N_piS, point, time, QFS)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, r_1N_2N_piS, point, time, QFS)
	   endif
	   return
	endif
c ... pi absorption
	if( rn() .lt. p_pi_abs(reactionID) ) then
         call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_helium3_pion_absorption(M_helium3, p_helium3, v_helium3,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, point, time, pi_abs)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFS)
		call internal_deuteron_pion_absorption(M_deuteron, p_deuteron, v_deuteron,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, point, time, pi_abs)
	   endif
	   return
	endif
c ... without 2ndary reaction
      call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFS)
      call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, QFS)
	if( N_num .eq. 3) then
         call put_stack(PID_helium3, p_helium3, v_helium3, point, time, QFS)
	else
         call put_stack(PID_proton, p_p, v_p, point, time, QFS)
         call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFS)
	endif
	return
	end




      subroutine S0_pim
      implicit NONE
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c external
	real rn
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c local 
      real p_S0, v_S0(3), p_pi, v_pi(3), p_helium3, v_helium3(3)
      real point(3), time, p_deuteron, v_deuteron(3) 
      real p_p, v_p(3)
      integer N_nucl, N_pickup, N_num, iflag
c constant
	integer reactionID / 5 /
c begin
c 5 Sigma- pi0 quasi-free production (first step)
      time = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
c 
      N_nucl = 4
      iflag = 0
c ... He4 K-  ->  S0 pi- He3   (1N-induced) 
	if(rn() .lt. r_1N_2N_S) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'S0 pi- He3'
         N_num = 3
         N_pickup = 1
         call reaction_at_rest_3( M_helium4, M_k,
     &            M_S0, M_pi, M_helium3,
     &            p_S0, p_pi, p_helium3, 
     &            v_S0, v_pi, v_helium3, N_nucl, N_pickup, iflag )
c ... He4 K-  ->  S0 pi- p d   (2N-induced)
      else
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'S0 pi- p d'
         N_num = 2
         N_pickup = 2
         call reaction_at_rest_4( M_helium4, M_k, 
     &            M_S0, M_pi, M_p, M_deuteron,
     &            p_S0, p_pi, p_p, p_deuteron, 
     &            v_S0, v_pi, v_p, v_deuteron, N_nucl, N_pickup, iflag )
      endif
c ... SL conversion
	if( rn() .lt. p_SL_conv(reactionID) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) '-- SL conv'
         call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
	   if( N_num .eq. 3) then
		call helium3_SL_conversion(M_helium3, p_helium3, v_helium3,
     &		M_S0, p_S0, v_S0, r_1N_2N_SLC, point, time, SLC)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFS)
		call deuteron_SL_conversion(M_deuteron, p_deuteron, v_deuteron,
     &		M_S0, p_S0, v_S0, r_1N_2N_SLC, point, time, SLC)
	   endif
	   return
	endif
c ... YN scattering
	if( rn() .lt. p_Y_scat(reactionID) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) '-- YN scat'
         call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_helium3_scattering(
     &		PID_helium3, M_helium3, p_helium3, v_helium3,
     &		PID_Sigma0, M_S0, p_S0, v_S0, r_1N_2N_SNS, point, time, QFS)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_Sigma0, M_S0, p_S0, v_S0, r_1N_2N_SNS, point, time, QFS)
	   endif
	   return
	endif
c ... piN scattering
	if( rn() .lt. p_pi_scat(reactionID) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) '-- piN scat'
         call put_stack(PID_Sigma0, p_S0, v_S0, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_helium3_scattering(
     &		PID_helium3, M_helium3, p_helium3, v_helium3,
     &		-PID_pion, M_pi, p_pi, v_pi, r_1N_2N_piS, point, time, QFS)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFS)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		-PID_pion, M_pi, p_pi, v_pi, r_1N_2N_piS, point, time, QFS)
	   endif
	   return
	endif
c ... pi absorption
	if( rn() .lt. p_pi_abs(reactionID) ) then
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) '-- pi abs'
         call put_stack(PID_Sigma0, p_S0, v_S0, point, time, QFS)
	   if( N_num .eq. 3) then
		call internal_helium3_pion_absorption(M_helium3, p_helium3, v_helium3,
     &		-PID_pion, M_pi, p_pi, v_pi, point, time, pi_abs)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFS)
		call internal_deuteron_pion_absorption(M_deuteron, p_deuteron, v_deuteron,
     &		-PID_pion, M_pi, p_pi, v_pi, point, time, pi_abs)
	   endif
	   return
	endif
c ... without 2ndary reaction
c>	if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) '-- single step only'
      call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
      call put_stack(PID_Sigma0, p_S0, v_S0, point, time, QFS)
	if( N_num .eq. 3) then
         call put_stack(PID_helium3, p_helium3, v_helium3, point, time, QFS)
	else
         call put_stack(PID_proton, p_p, v_p, point, time, QFS)
         call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFS)
	endif
	return
	end




      subroutine L_pi0
      implicit NONE
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c external
	real rn
c local 
      real point(3), time
      real p_pi0, v_pi0(3), p_triton, v_triton(3)
      real p_L, v_L(3), p_deuteron, v_deuteron(3) 
      real p_n, v_n(3)
      integer N_nucl, N_pickup, N_num, iflag
c constant
	integer reactionID / 6 /
c begin
c 6 Lambda pi0 quasi-free production (first step)
      time = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
c 
      N_nucl = 4
      iflag = 0
c ... He4 K-  ->  L pi0 t   (1N-induced) 
	if(rn() .lt. r_1N_2N_S) then
         N_num = 3
         N_pickup = 1
         call reaction_at_rest_3( M_helium4, M_k,
     &            M_L, M_pi0, M_triton,
     &            p_L, p_pi0, p_triton, 
     &            v_L, v_pi0, v_triton, N_nucl, N_pickup, iflag )
c ... He4 K-  ->  S- pi0 p d   (2N-induced)
      else
         N_num = 2
         N_pickup = 2
         call reaction_at_rest_4( M_helium4, M_k, 
     &            M_L, M_pi0, M_n, M_deuteron,
     &            p_L, p_pi0, p_n, p_deuteron, 
     &            v_L, v_pi0, v_n, v_deuteron, N_nucl, N_pickup, iflag )
      endif
c ... YN scattering
	if( rn() .lt. p_Y_scat(reactionID) ) then
         call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFL)
	   if( N_num .eq. 3) then
		call internal_triton_scattering(
     &		PID_triton, M_triton, p_triton, v_triton,
     &		PID_Lambda, M_L, p_L, v_L, r_1N_2N_SNS, point, time, QFL)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFL)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_Lambda, M_L, p_L, v_L, r_1N_2N_SNS, point, time, QFL)
	   endif
	   return
	endif
c ... piN scattering
	if( rn() .lt. p_pi_scat(reactionID) ) then
         call put_stack(PID_Lambda, p_L, v_L, point, time, QFL)
	   if( N_num .eq. 3) then
		call internal_triton_scattering(
     &		PID_triton, M_triton, p_triton, v_triton,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, r_1N_2N_piS, point, time, QFL)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFL)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, r_1N_2N_piS, point, time, QFL)
	   endif
	   return
	endif
c ... pi absorption
	if( rn() .lt. p_pi_abs(reactionID) ) then
         call put_stack(PID_Lambda, p_L, v_L, point, time, QFL)
	   if( N_num .eq. 3) then
		call internal_triton_pion_absorption(M_triton, p_triton, v_triton,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, point, time, pi_abs)
	   else
            call put_stack(PID_neutron, p_n, v_n, point, time, QFL)
		call internal_deuteron_pion_absorption(M_deuteron, p_deuteron, v_deuteron,
     &		PID_pi0, M_pi0, p_pi0, v_pi0, point, time, pi_abs)
	   endif
	   return
	endif
c ... without 2ndary reaction
      call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFL)
      call put_stack(PID_Lambda, p_L, v_L, point, time, QFL)
	if( N_num .eq. 3) then
         call put_stack(PID_triton, p_triton, v_triton, point, time, QFL)
	else
         call put_stack(PID_neutron, p_n, v_n, point, time, QFL)
         call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFL)
	endif
	return
	end




      subroutine L_pim
      implicit NONE
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_1N_2N_piEx_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c external
	real rn
c local 
      real point(3), time, p_p, v_p(3)
      real p_pi, v_pi(3), p_helium3, v_helium3(3)
      real p_L, v_L(3), p_deuteron, v_deuteron(3) 
      integer N_nucl, N_pickup, N_num, iflag
c constant
	integer reactionID / 7 /
c begin
c 7 Lambda pi- quasi-free production (first step)
      time = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
c 
      N_nucl = 4
      iflag = 0
c ... He4 K-  ->  L pi- He3   (1N-induced) 
	if(rn() .lt. r_1N_2N_S) then
         N_num = 3
         N_pickup = 1
         call reaction_at_rest_3( M_helium4, M_k,
     &            M_L, M_pi, M_helium3,
     &            p_L, p_pi, p_helium3, 
     &            v_L, v_pi, v_helium3, N_nucl, N_pickup, iflag )
c ... He4 K-  ->  L pi- p d   (2N-induced)
      else
         N_num = 2
         N_pickup = 2
         call reaction_at_rest_4( M_helium4, M_k, 
     &            M_L, M_pi, M_p, M_deuteron,
     &            p_L, p_pi, p_p, p_deuteron, 
     &            v_L, v_pi, v_p, v_deuteron, N_nucl, N_pickup, iflag )
      endif
c ... YN scattering
	if( rn() .lt. p_Y_scat(reactionID) ) then
         call put_stack(-PID_pion, p_pi, v_pi, point, time, QFL)
	   if( N_num .eq. 3) then
		call internal_helium3_scattering(
     &		PID_helium3, M_helium3, p_helium3, v_helium3,
     &		PID_Lambda, M_L, p_L, v_L, r_1N_2N_SNS, point, time, QFL)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFL)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_Lambda, M_L, p_L, v_L, r_1N_2N_SNS, point, time, QFL)
	   endif
	   return
	endif
c ... piN scattering
	if( rn() .lt. p_pi_scat(reactionID) ) then
         call put_stack(PID_Lambda, p_L, v_L, point, time, QFL)
	   if( N_num .eq. 3) then
		call internal_helium3_scattering(
     &		PID_helium3, M_helium3, p_helium3, v_helium3,
     &		-PID_pion, M_pi, p_pi, v_pi, r_1N_2N_piS, point, time, QFL)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFL)
		call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		-PID_pion, M_pi, p_pi, v_pi, r_1N_2N_piS, point, time, QFL)
	   endif
	   return
	endif
c ... pi absorption
	if( rn() .lt. p_pi_abs(reactionID) ) then
         call put_stack(PID_Lambda, p_L, v_L, point, time, QFL)
	   if( N_num .eq. 3) then
		call internal_helium3_pion_absorption(M_helium3, p_helium3, v_helium3,
     &		-PID_pion, M_pi, p_pi, v_pi, point, time, pi_abs)
	   else
            call put_stack(PID_proton, p_p, v_p, point, time, QFL)
		call internal_deuteron_pion_absorption(M_deuteron, p_deuteron, v_deuteron,
     &		-PID_pion, M_pi, p_pi, v_pi, point, time, pi_abs)
	   endif
	   return
	endif
c ... without 2ndary reaction
      call put_stack(-PID_pion, p_pi, v_pi, point, time, QFL)
      call put_stack(PID_Lambda, p_L, v_L, point, time, QFL)
	if( N_num .eq. 3) then
         call put_stack(PID_helium3, p_helium3, v_helium3, point, time, QFL)
	else
         call put_stack(PID_proton, p_p, v_p, point, time, QFL)
         call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFL)
	endif
	return
	end




	subroutine internal_triton_scattering(
     &		PID_residual, M_residual, p_residual, v_residual, 
     &		PID_proj, M_proj, p_proj, v_proj, r_1N_2N, point, time, RID)
	implicit none
c   input
	real M_residual, p_residual, v_residual(3)
	real M_proj, p_proj, v_proj(3)
	real r_1N_2N, point(3), time
	integer PID_residual, PID_proj, RID
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /masses/ elementary mass
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/ nucler mass
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c   local
	real p_n1, v_n1(3), p_deuteron, v_deuteron(3)
	real p_p1, v_p1(3), p_n2, v_n2(3)
	integer N_nucl, N_pickup, iflag, p_prob
c   external
	real rn
c begin
      iflag = -1
c Delta-resonance for pion
	if(PID_proj .eq. PID_pion) then
	   p_prob =  3. / 5.
	else if(PID_proj .eq. -PID_pion) then
	   p_prob =  2. / 5.
	else 
	   p_prob =  1. / 3.
	endif
c residual nuclei is triton (3 nucleon system)
         N_nucl = 3
         N_pickup = 1
c ... single-nucleon knock out
	   if( rn() .lt. r_1N_2N ) then
                  call reaction_in_flight_3(
     &		   M_residual, p_residual, v_residual, M_proj, p_proj, v_proj, 
     &               M_proj, M_n,  M_deuteron,
     &               p_proj, p_n1, p_deuteron, 
     &               v_proj, v_n1, v_deuteron, N_nucl, N_pickup, iflag)
		      if(iflag .eq. 0) then
                     call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
                     call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
                     call  put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, RID)
		      else
c		   	   write(*,*) ' warning -1 cannot breakup nuclei' 
c			   write(*,*) M_residual, p_residual, v_residual
c			   write(*,*) M_proj, p_proj, v_proj
                     call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
                     call  put_stack(PID_residual, p_residual, v_residual, point, time, RID)
		      endif
c ... single-nucleon knock out with nuclear breakup
	   else
		   if(rn() .lt. p_prob) then
                  call breakup_in_flight_4(
     &		   M_residual, p_residual, v_residual, M_proj, p_proj, v_proj, 
     &               M_proj, M_p,  M_n,  M_n, 
     &               p_proj, p_p1, p_n1, p_n2,  
     &               v_proj, v_p1, v_n1, v_n2, N_nucl, N_pickup, iflag)
		   else
                  call breakup_in_flight_4(
     &		   M_residual, p_residual, v_residual, M_proj, p_proj, v_proj, 
     &               M_proj, M_n,  M_n,  M_p,  
     &               p_proj, p_n1, p_n2, p_p1,  
     &               v_proj, v_n1, v_n2, v_p1, N_nucl, N_pickup, iflag)
		   endif
		      if(iflag .eq. 0) then
                     call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
                     call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
                     call  put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
                     call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
		      else
c		   	   write(*,*) ' warning -2 cannot breakup nuclei' 
c			   write(*,*) M_residual, p_residual, v_residual
c			   write(*,*) M_proj, p_proj, v_proj
                     call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
                     call  put_stack(PID_residual, p_residual, v_residual, point, time, RID)
		      endif
	   endif
	return
	end





	subroutine internal_helium3_scattering(
     &		PID_residual, M_residual, p_residual, v_residual, 
     &		PID_proj, M_proj, p_proj, v_proj, r_1N_2N, point, time, RID)
	implicit none
c   input
	real M_residual, p_residual, v_residual(3)
	real M_proj, p_proj, v_proj(3)
	real r_1N_2N, point(3), time
	integer PID_residual, PID_proj, RID
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /masses/ elementary mass
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/ nucler mass
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c   local
	real p_n1, v_n1(3), p_deuteron, v_deuteron(3)
	real p_p1, v_p1(3), p_p2, v_p2(3)
	integer N_nucl, N_pickup, iflag, p_prob
c   external
	real rn
c begin
	iflag = -1
c Delta-resonance for pion
	if(PID_proj .eq. PID_pion) then
	   p_prob =  6. / 7.
	else if(PID_proj .eq. -PID_pion) then
	   p_prob =  1. / 7.
	else 
	   p_prob =  2. / 3.
	endif
c residual nuclei is triton (3 nucleon system)
         N_nucl = 3
         N_pickup = 1
c ... single-nucleon knock out
	   if( rn() .lt. r_1N_2N ) then
               call reaction_in_flight_3(
     &		   M_residual, p_residual, v_residual, M_proj, p_proj, v_proj, 
     &               M_proj, M_p,  M_deuteron,
     &               p_proj, p_p1, p_deuteron, 
     &               v_proj, v_p1, v_deuteron, N_nucl, N_pickup, iflag)
		   if(iflag .eq. 0) then
                     call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
                     call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
                     call  put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, RID)
		   else
c			write(*,*) ' warning -3 cannot breakup nuclei' 
c			write(*,*) M_residual, p_residual, v_residual
c			write(*,*) M_proj, p_proj, v_proj
                  call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
                  call  put_stack(PID_residual, p_residual, v_residual, point, time, RID)
		   endif
c ... single-nucleon knock-out with nuclear breakup
	   else
		   if(rn() .lt. p_prob) then
                  call breakup_in_flight_4(
     &		   M_residual, p_residual, v_residual, M_proj, p_proj, v_proj, 
     &               M_proj, M_p,  M_p,  M_n, 
     &               p_proj, p_p1, p_p2, p_n1,  
     &               v_proj, v_p1, v_p2, v_n1, N_nucl, N_pickup, iflag)
		   else
                  call breakup_in_flight_4(
     &		   M_residual, p_residual, v_residual, M_proj, p_proj, v_proj, 
     &               M_proj, M_n,  M_p,  M_p,  
     &               p_proj, p_n1, p_p1, p_p2,  
     &               v_proj, v_n1, v_p1, v_p2, N_nucl, N_pickup, iflag)
		   endif
		   if(iflag .eq. 0) then
                  call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
                  call  put_stack(PID_proton, p_p2, v_p2, point, time, RID)
                  call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
                  call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
		   else
c		      write(*,*) ' warning -4 cannot breakup nuclei' 
c			write(*,*) M_residual, p_residual, v_residual
c			write(*,*) M_proj, p_proj, v_proj
                  call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
                  call  put_stack(PID_residual, p_residual, v_residual, point, time, RID)
		   endif
	   endif
	return
	end





	subroutine internal_deuteron_scattering(
     &		PID_residual, M_residual, p_residual, v_residual, 
     &		PID_proj, M_proj, p_proj, v_proj, r_1N_2N, point, time, RID)
	implicit none
c   input
	real M_residual, p_residual, v_residual(3)
	real M_proj, p_proj, v_proj(3)
	real r_1N_2N, point(3), time
	integer PID_residual, PID_proj, RID
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /masses/ elementary mass
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c   local
	real p_n1, v_n1(3)
	real p_p1, v_p1(3)
	integer N_nucl, N_pickup, iflag, p_prob
c   external
	real rn
c begin
      iflag = -1
c residual nuclei is deuteron
c Delta-resonance for pion
	if(PID_proj .eq. PID_pion) then
	   p_prob =  3. / 4.
	else if(PID_proj .eq. -PID_pion) then
	   p_prob =  1. / 4.
	else 
	   p_prob =  1. / 2.
	endif
c ... single-nucleon knock out
         N_nucl = 2
         N_pickup = 1
		   if(rn() .lt. p_prob) then
                 call reaction_in_flight_3(
     &		   M_residual, p_residual, v_residual, M_proj, p_proj, v_proj, 
     &               M_proj, M_p,  M_n,
     &               p_proj, p_p1, p_n1, 
     &               v_proj, v_p1, v_n1, N_nucl, N_pickup, iflag)
		   else
                  call reaction_in_flight_3(
     &		   M_residual, p_residual, v_residual, M_proj, p_proj, v_proj, 
     &               M_proj, M_n,  M_p,
     &               p_proj, p_n1, p_p1, 
     &               v_proj, v_n1, v_p1, N_nucl, N_pickup, iflag)
 		   endif
		   if(iflag .eq. 0) then
                  call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
                  call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
                  call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
		   else
c		      write(*,*) ' warning -5 cannot breakup nuclei' 
c			write(*,*) M_residual, p_residual, v_residual
c			write(*,*) M_proj, p_proj, v_proj
                  call  put_stack(PID_proj, p_proj, v_proj, point, time, RID)
                  call  put_stack(PID_residual, p_residual, v_residual, point, time, RID)
		   endif
	return
	end




	subroutine internal_triton_pion_absorption(M_residual, p_residual, v_residual, 
     &		PID_pi_input, M_pi_input, p_pi, v_pi, point, time, RID)
c ... internal pion absorption
	implicit none
c   input
	real M_residual, p_residual, v_residual(3)
	real M_pi_input, p_pi, v_pi(3), point(3), time
	integer PID_pi_input, RID
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /masses/ elementary mass
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/ nucler mass
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c   local
	integer N_nucl, N_pickup, iflag
	real p_n1, v_n1(3), p_n2, v_n2(3), p_n3, v_n3(3)
	real p_p1, v_p1(3), p_p2, v_p2(3)
c   external
	real rn
c begin
      iflag = 0
         N_nucl = 3
         N_pickup = 2
	      if( PID_pi_input .eq. -PID_pion ) then
               call reaction_in_flight_3(
     &            M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &            M_n,  M_n,  M_n, 
     &            p_n1, p_n2, p_n3,
     &            v_n1, v_n2, v_n3, N_nucl, N_pickup, iflag )
               call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
               call  put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
               call  put_stack(PID_neutron, p_n3, v_n3, point, time, RID)
	      else if( PID_pi_input .eq. PID_pi0 ) then
		   if(rn() .lt. 2./3.) then
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &               M_p,  M_n,  M_n,   
     &               p_p1, p_n1, p_n2, 
     &               v_p1, v_n1, v_n2, N_nucl, N_pickup, iflag )
		   else
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &               M_n,  M_n,  M_p, 
     &               p_n1, p_n2, p_p1,
     &               v_n1, v_n2, v_p1, N_nucl, N_pickup, iflag )
		   endif
               call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
               call  put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
               call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
	      else if( PID_pi_input .eq. +PID_pion ) then
		   if(rn() .lt. 2./3.) then
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &               M_p,  M_p,  M_n,   
     &               p_p1, p_p2, p_n1, 
     &               v_p1, v_p2, v_n1, N_nucl, N_pickup, iflag )
		   else
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &               M_n,  M_p,  M_p, 
     &               p_n1, p_p2, p_p1,
     &               v_n1, v_p2, v_p1, N_nucl, N_pickup, iflag )
		   endif
               call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
               call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
               call  put_stack(PID_proton, p_p2, v_p2, point, time, RID)
	      endif
	return
	end





	subroutine internal_helium3_pion_absorption(M_residual, p_residual, v_residual, 
     &		PID_pi_input, M_pi_input, p_pi, v_pi, point, time, RID)
c ... internal pion absorption
	implicit none
c   input
	real M_residual, p_residual, v_residual(3)
	real M_pi_input, p_pi, v_pi(3), point(3), time
	integer PID_pi_input, RID
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /masses/ elementary mass
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/ nucler mass
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c   local
	integer N_nucl, N_pickup, iflag
	real p_n1, v_n1(3), p_n2, v_n2(3)
	real p_p1, v_p1(3), p_p2, v_p2(3), p_p3, v_p3(3)
c   external
	real rn
c begin
         N_nucl = 3
         N_pickup = 2
         iflag = 0
	      if( PID_pi_input .eq. -PID_pion ) then
c>	         if(debug_F .and. (ev_NUM .ge. ev_error)) then
c>	            write(*,*) 'pi- He3 -> p n n '
c>	            write(*,*) M_residual, p_residual, v_residual
c>	            write(*,*) M_pi_input, p_pi, v_pi
c>	         endif
		   if(rn() .lt. 1./3.) then
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &               M_n,  M_p,  M_n, 
     &               p_n1, p_p1, p_n2,
     &               v_n1, v_p1, v_n2, N_nucl, N_pickup, iflag )
		   else
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &               M_n,  M_n,  M_p,   
     &               p_n1, p_n2, p_p1, 
     &               v_n1, v_n2, v_p1, N_nucl, N_pickup, iflag )
		   endif
c>	         if(debug_F .and. (ev_NUM .ge. ev_error)) then
c>	            write(*,*) '?p1', p_n1, v_n1
c>	            write(*,*) '?p2', p_n2, v_n2
c>	            write(*,*) '?p3', p_p1, v_p1
c>	         endif
               call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
               call  put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
               call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
	      else if( PID_pi_input .eq. PID_pi0 ) then
c>	         if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'pi0 He3 -> p p n '
		   if(rn() .lt. 1./3.) then
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &               M_p,  M_p,  M_n, 
     &               p_p1, p_p2, p_n1,
     &               v_p1, v_p2, v_n1, N_nucl, N_pickup, iflag )
		   else
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &               M_p,  M_n,  M_p,   
     &               p_p1, p_n1, p_p2, 
     &               v_p1, v_n1, v_p2, N_nucl, N_pickup, iflag )
		   endif
               call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
               call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
               call  put_stack(PID_proton, p_p2, v_p2, point, time, RID)
	      else if( PID_pi_input .eq. +PID_pion ) then
c>	         if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'pi+ He3 -> p p p '
               call reaction_in_flight_3(
     &            M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &            M_p,  M_p,  M_p,   
     &            p_p1, p_p2, p_p3, 
     &            v_p1, v_p2, v_p3, N_nucl, N_pickup, iflag )
               call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
               call  put_stack(PID_proton, p_p2, v_p2, point, time, RID)
               call  put_stack(PID_proton, p_p3, v_p3, point, time, RID)
	      endif
	return
	end





	subroutine internal_deuteron_pion_absorption(M_residual, p_residual, v_residual, 
     &		PID_pi_input, M_pi_input, p_pi, v_pi, point, time, RID)
c ... internal pion absorption
	implicit none
c   input
	real M_residual, p_residual, v_residual(3)
	real M_pi_input, p_pi, v_pi(3), point(3), time
	integer PID_pi_input, RID
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c   local
	integer N_nucl, N_pickup, iflag
	real p_n1, v_n1(3), p_n2, v_n2(3)
	real p_p1, v_p1(3), p_p2, v_p2(3)
c begin
         N_nucl = 2
         N_pickup = 2
         iflag = 0
	      if( PID_pi_input .eq. -PID_pion ) then
               call reaction_in_flight_2(
     &		M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &            M_n,  M_n,   
     &            p_n1, p_n2, 
     &            v_n1, v_n2, iflag )
               call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
               call  put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
	      else if( PID_pi_input .eq. PID_pi0 ) then
               call reaction_in_flight_2(
     &		M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &            M_n,  M_p,   
     &            p_n1, p_p1, 
     &            v_n1, v_p1, iflag )
               call  put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
               call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
	      else if( PID_pi_input .eq. +PID_pion ) then
               call reaction_in_flight_2(
     &		M_residual, p_residual, v_residual, M_pi_input, p_pi, v_pi,
     &            M_n,  M_n,   
     &            p_p1, p_p2, 
     &            v_p1, v_p2, iflag )
               call  put_stack(PID_proton, p_p1, v_p1, point, time, RID)
               call  put_stack(PID_proton, p_p2, v_p2, point, time, RID)
	      endif
	return
	end





	subroutine triton_SL_conversion(M_residual, p_residual, v_residual,
     &		M_Y, p_Y, v_Y, r_1N_2N, point, time, RID)
c --- SL conversion --------
	implicit none
c   input
	real M_residual, p_residual, v_residual(3)
	real M_Y, p_Y, v_Y(3), r_1N_2N, point(3), time
	integer RID
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c   local
	integer N_nucl, N_pickup, iflag
	real p_deuteron, v_deuteron(3), p_L, v_L(3)
	real p_n1, v_n1(3), p_n2, v_n2(3), p_n3, v_n3(3)
	real p_p1, v_p1(3), p_p2, v_p2(3)
c   external
	real rn
c begin
 	if(M_residual .ne. M_triton) write(*,*) 'error!'
         N_nucl = 3
         iflag = 0
            if( rn() .lt. r_1N_2N ) then 
               N_pickup = 1
c ...    t S- -> n L n n 
	         if( M_Y .eq. M_Sm ) then
			go to 10
c ...    t S0 -> n L d
	         else if( M_Y .eq. M_S0 ) then
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &               M_L, M_n,  M_deuteron, 
     &               p_L, p_n1, p_deuteron,
     &               v_L, v_n1, v_deuteron, N_nucl, N_pickup, iflag )
      	      call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
      	      call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, RID)
c ...    t Sp -> p L d
	         else if( M_Y .eq. M_Sp ) then
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &               M_L, M_p,  M_deuteron, 
     &               p_L, p_p1, p_deuteron,
     &               v_L, v_p1, v_deuteron, N_nucl, N_pickup, iflag )
      	      call put_stack(PID_proton, p_p1, v_p1, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
      	      call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, RID)
               endif
            else
               N_pickup = 2
c ...    t S- -> n L n n 
	         if( M_Y .eq. M_Sm ) then
10                call reaction_in_flight_4(
     &               M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &               M_n,  M_L, M_n,  M_n,  
     &               p_n1, p_L, p_n2, p_n3, 
     &               v_n1, v_L, v_n2, v_n3, N_nucl, N_pickup, iflag )
                  call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	      call put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
      	      call put_stack(PID_neutron, p_n3, v_n3, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
c ...    t S0 -> n L p n
	         else if( M_Y .eq. M_S0 ) then
			if( rn() .lt. 2./3. ) then
                     call reaction_in_flight_4(
     &                  M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &                  M_p,  M_L, M_n,  M_n,  
     &                  p_p1, p_L, p_n1, p_n2, 
     &                  v_p1, v_L, v_n1, v_n2, N_nucl, N_pickup, iflag )
      	      else 
                     call reaction_in_flight_4(
     &                  M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &                  M_n,  M_L, M_n,  M_p,  
     &                  p_n1, p_L, p_n2, p_p1, 
     &                  v_n1, v_L, v_n2, v_p1, N_nucl, N_pickup, iflag )
      	      endif
      	      call put_stack(PID_proton, p_p1, v_p1, point, time, RID)
                  call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	      call put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
c ...    t Sp -> p L p n
	         else if( M_Y .eq. M_Sp ) then
			if( rn() .lt. 2./3. ) then
                     call reaction_in_flight_4(
     &                  M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &                  M_p,  M_L, M_p,  M_n,  
     &                  p_p1, p_L, p_p2, p_n1, 
     &                  v_p1, v_L, v_p2, v_n1, N_nucl, N_pickup, iflag )
      	      else 
                     call reaction_in_flight_4(
     &                  M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &                  M_p,  M_L, M_n,  M_p,  
     &                  p_p1, p_L, p_n1, p_p2, 
     &                  v_p1, v_L, v_n1, v_p2, N_nucl, N_pickup, iflag )
      	      endif
      	      call put_stack(PID_proton, p_p1, v_p1, point, time, RID)
      	      call put_stack(PID_proton, p_p2, v_p2, point, time, RID)
                  call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
               endif
            endif
	return
	end




	subroutine helium3_SL_conversion(M_residual, p_residual, v_residual,
     &		M_Y, p_Y, v_Y, r_1N_2N, point, time, RID)
c --- SL conversion --------
	implicit none
c var 
c   input
	real M_residual, p_residual, v_residual(3)
	real M_Y, p_Y, v_Y(3), r_1N_2N, point(3), time
	integer RID
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c   local
	integer N_nucl, N_pickup, iflag
	real p_deuteron, v_deuteron(3), p_L, v_L(3)
	real p_n1, v_n1(3), p_n2, v_n2(3)
	real p_p1, v_p1(3), p_p2, v_p2(3)
c   external
	real rn
c begin
	if(M_residual .ne. M_helium3) write(*,*) 'error!'
         N_nucl = 3
         iflag = 0
            if( rn() .lt. r_1N_2N ) then 
               N_pickup = 1
c ...    He3 S- -> n L d 
	         if( M_Y .eq. M_Sm ) then
c>	            if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'He3 S- -> n L d'
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &               M_L, M_n,  M_deuteron, 
     &               p_L, p_n1, p_deuteron,
     &               v_L, v_n1, v_deuteron, N_nucl, N_pickup, iflag )
      	      call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
      	      call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, RID)
c ...    He3 S0 -> p L d
	         else if( M_Y .eq. M_S0 ) then
c>	            if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'He3 S0 -> p L d'
                  call reaction_in_flight_3(
     &               M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &               M_L, M_p,  M_deuteron, 
     &               p_L, p_p1, p_deuteron,
     &               v_L, v_p1, v_deuteron, N_nucl, N_pickup, iflag )
      	      call put_stack(PID_proton, p_p1, v_p1, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
      	      call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, RID)
c ...    He3 Sp -> p L p p (impossible from K- He4 reaction)
	         else if( M_Y .eq. M_Sp ) then
			write(*,*) ' impossible reaction requested : He3 Sp -> p L p p'
			return
               endif
            else
               N_pickup = 2
c ...    He3 S- -> n L p n 
	         if( M_Y .eq. M_Sm ) then
c>	            if(debug_F .and. (ev_NUM .ge. ev_error)) 
c>	             &	write(*,*) 'He3 S- -> n L p n',N_nucl, N_pickup
			if( rn() .lt. 2./3. ) then
                     call reaction_in_flight_4(
     &                  M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &                  M_n,  M_L, M_n,  M_p,  
     &                  p_n1, p_L, p_n2, p_p1, 
     &                  v_n1, v_L, v_n2, v_p1, N_nucl, N_pickup, iflag )
			else
                     call reaction_in_flight_4(
     &                  M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &                  M_n,  M_L, M_p,  M_n,   
     &                  p_n1, p_L, p_p1, p_n2, 
     &                  v_n1, v_L, v_p1, v_n2, N_nucl, N_pickup, iflag )
			endif
                  call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	      call put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
      	      call put_stack(PID_proton, p_p1, v_p1, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
c ...    He3 S0 -> n L p p
	         else if( M_Y .eq. M_S0 ) then
c>	         	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'He3 S0 -> n L p p'
			if( rn() .lt. 2./3. ) then
                     call reaction_in_flight_4(
     &                  M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &                  M_n,  M_L, M_p,  M_p,  
     &                  p_n1, p_L, p_p1, p_p2, 
     &                  v_n1, v_L, v_p1, v_p2, N_nucl, N_pickup, iflag )
      	      else 
                     call reaction_in_flight_4(
     &                  M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &                  M_p,  M_L, M_p,  M_n,  
     &                  p_p1, p_L, p_p2, p_n1, 
     &                  v_p1, v_L, v_p2, v_n1, N_nucl, N_pickup, iflag )
      	      endif
      	      call put_stack(PID_proton, p_p1, v_p1, point, time, RID)
      	      call put_stack(PID_proton, p_p2, v_p2, point, time, RID)
                  call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
c ...    He3 Sp -> p L p p (impossible from K- He4 reaction)
	         else if( M_Y .eq. M_Sp ) then
			write(*,*) ' impossible reaction requested : He3 Sp -> p L p p'
			return
               endif
            endif
	return
	end





	subroutine deuteron_SL_conversion(M_residual, p_residual, v_residual,
     &		M_Y, p_Y, v_Y, r_1N_2N, point, time, RID)
c --- SL conversion --------
	implicit none
c var 
c   input
	real M_residual, p_residual, v_residual(3)
	real M_Y, p_Y, v_Y(3), r_1N_2N, point(3), time
	integer RID
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c   local
	integer N_nucl, N_pickup, iflag
	real p_L, v_L(3)
	real p_n1, v_n1(3), p_n2, v_n2(3)
	real p_p1, v_p1(3), p_p2, v_p2(3)
c external
	real rn
c begin
	if(M_residual .ne. M_deuteron) write(*,*) 'error!'
      N_nucl = 2
      N_pickup = 1
      iflag = 0
c ... d S- -> n n L 
	if( M_Y .eq. M_Sm ) then
            call reaction_in_flight_3(
     &            M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &            M_L, M_n,  M_n,  
     &            p_L, p_n1, p_n2, 
     &            v_L, v_n1, v_n2, N_nucl, N_pickup, iflag )
      	call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	call put_stack(PID_neutron, p_n2, v_n2, point, time, RID)
      	call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
c ... d S0 -> p n L 
	else if( M_Y .eq. M_S0 ) then
		if(rn() .lt. 0.5) then
               call reaction_in_flight_3(
     &            M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &            M_L, M_p,  M_n,  
     &            p_L, p_p1, p_n1, 
     &            v_L, v_p1, v_n1, N_nucl, N_pickup, iflag )
		else
               call reaction_in_flight_3(
     &            M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &            M_L, M_n,  M_p,  
     &            p_L, p_n1, p_p1, 
     &            v_L, v_n1, v_p1, N_nucl, N_pickup, iflag )
		endif
      	call put_stack(PID_proton, p_p1, v_p1, point, time, RID)
      	call put_stack(PID_neutron, p_n1, v_n1, point, time, RID)
      	call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
c ... d S+ -> p p L 
	else if( M_Y .eq. M_Sp ) then
            call reaction_in_flight_3(
     &            M_residual, p_residual, v_residual, M_Y, p_Y, v_Y,
     &            M_L, M_p,  M_p,  
     &            p_L, p_p1, p_p2, 
     &            v_L, v_p1, v_p2, N_nucl, N_pickup, iflag )
      	call put_stack(PID_proton, p_p1, v_p1, point, time, RID)
      	call put_stack(PID_proton, p_p2, v_p2, point, time, RID)
      	call put_stack(PID_Lambda, p_L, v_L, point, time, RID)
      endif
	return
	end
