	subroutine K_trigger(Trigger)
	implicit none
c var
c ... common for setup
	common /TC/ TC_up, TC_down
	integer TC_up, TC_down
	integer n_start, n_end
	common /ncount/ n_start, n_end
	common /vetoc/ VDC_VETO_start, VDC_VETO_end, BDC_VETO_start, BDC_VETO_end
	integer VDC_VETO_start, VDC_VETO_end, BDC_VETO_start, BDC_VETO_end
c ...	common /NC_data/ for neutron counter buffer 
	real BS(20, 2), BSv(20, 3), BSp(20, 3)
	integer BSptr, iBS(20)
	logical LBS(20, 2)
	common /NC_data/ BSptr, iBS, LBS(20, 2), BS, BSv, BSp
c ... common /TC_data/ for TC info.
	integer PID_trg
	real dL_thin, dL_thick, p_trg, t_trg, v_trg(3), pt_trg(3) 
	common /TC_data/ PID_trg, dL_thin, dL_thick, p_trg, t_trg, v_trg, pt_trg
c ... common /setup/ for simulation run-condition, counter resolution and its efficiency
	integer FF_knucl_decay, multi_set, k_decay_set
	logical Kstop_cor
      real  delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff
      common /setup/ delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff,
     &	FF_knucl_decay, multi_set, k_decay_set, Kstop_cor
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common for /VDC/ VDC specification
	real VDC_resolution, VDC_threshold
	common /VDC/ VDC_resolution, VDC_threshold
c ... constant /CBGL/ for constant neutron background level
	real CBG_level
	common /CBGL/ CBG_level
c ... constant
	integer Will_Hit /-1/
c local
	logical Trigger
	logical Dbl_Arm_Hit, Chrg_Hit
	integer k, j, iv, PID, stack_size, n_reactionID, n_hit
	real dE_thick 
	real point_n(3), v_n(3), p_n, time_n
	real dE, dL, point(3), vector(3), momentum, time
	real dE2, dL2, point2(3), vector2(3), momentum2, time2
	real dE3, dL3, point3(3), vector3(3), momentum3, time3
	integer hit, hit2, hit3, PIDp, PIDp2, PIDp3 
	integer sel1/0/, sel2/0/, sel3/0/, sel4/0/, non_sel/0/
c external
	real Gauss, rn
	integer neutron_Travel, gamma_Travel
c begin
	Trigger = .false.

c check whether Veto counters are not fired
	sel1 = sel1 + 1
c	write(*,*) 'sel1', sel1, sel2, sel3, sel4 

      do k = VDC_VETO_start, BDC_VETO_end
         call object_information(k, hit, dE, dL, 
     &			point, vector, momentum, time, PID)
	   if (hit .ne. 0) return
	EndDo
	sel2 = sel2 + 1
c	write(*,*) 'sel2', sel1, sel2, sel3, sel4 

c No multiple tracks in BDC
      call object_information(2, hit, dE, dL, 
     &			point, vector, momentum, time, PID)
	if (hit .ne. 0) return
	sel3 = sel3 + 1
c	write(*,*) 'sel3', sel1, sel2, sel3, sel4, TC_up

c trigger counter info.
	dL_thin = 0.
	dL_thick = 0.
	dE_thick = 0.
	p_trg = 0.
	PID_trg = 0
	t_trg = 0.
	v_trg(1) = 0.
	v_trg(2) = 1.
	v_trg(3) = 0.
	Do iv = 1, 3
	   pt_trg(iv) = 10000.
	endDo
      call object_information(TC_up, hit, dE, dL, 
     &			point, vector, momentum, time, PIDp)
c	write(*,*) 'TC_up', hit
	if(hit.eq.1) then
	   dL = Gauss(dL, TC_eff*sqrt(dL))  / 10000.
         call object_information(TC_up+1, hit2, dE2, dL2, 
     &			point2, vector2, momentum2, time2, PIDp2)
	   dL2 = Gauss(dL2, TC_eff*sqrt(dL2))  / 10000.
         call object_information(TC_down, hit3, dE3, dL3, 
     &			point3, vector3, momentum3, time3, PIDp3)
	   if (hit3 .ne. 0) return
         call object_information(48, hit3, dE3, dL3, 
     &			point3, vector3, momentum3, time3, PIDp3)
	   if(abs(PIDp3).eq.2 .and. momentum3.gt.220.)
     &	call td_Hf1(200, dE3, 1.)
c?????
c	write(*,*) 'TC_up PID, p, dE, VDC_threshold, VDC_resolution', PIDp3, momentum3, dE3, VDC_threshold, VDC_resolution
	   if(dE3 .lt. VDC_threshold) return
	else
         call object_information(TC_down, hit, dE, dL, 
     &			point, vector, momentum, time, PIDp)
c	write(*,*) 'TC_down', hit
	   if(hit.eq.1) then
	      dL = Gauss(dL, TC_eff*sqrt(dL))  / 10000.
            call object_information(TC_down+1, hit2, dE2, dL2, 
     &			point2, vector2, momentum2, time2, PIDp2)
	      dL2 = Gauss(dL2, TC_eff*sqrt(dL2))  / 10000.
            call object_information(49, hit3, dE3, dL3, 
     &			point3, vector3, momentum3, time3, PIDp3)
	      if(abs(PIDp3).eq.2 .and. momentum3.gt.220.)
     &	   call td_Hf1(200, dE3, 1.)
c     &	write(*,*) 'TC_down', PIDp3, momentum3, dE3
	      if(dE3 .lt. VDC_threshold) return
	   else
	   	return
	   endif
	endif
	dL_thin = dL
	dL_thick = dL2
	dE_thick = dE2
	p_trg = momentum
	PID_trg = PIDp
	t_trg = time
	Do iv = 1, 3
	   v_trg(iv) = vector(iv)
	   pt_trg(iv) = point(iv)
	endDo
	pt_trg(1) = pt_trg(1) + gauss(0., VDC_resolution)
	pt_trg(3) = pt_trg(3) + gauss(0., VDC_resolution)
	
	if(abs(PID_trg) .eq. PID_pion .and. p_trg .gt. 150.) then
	   call td_hf1(103, dL_thick/dE_thick, 1.)
	endif

c put neutron counter information into buffer
	BSptr = 0
      call get_stack_size( stack_size )
c	write(*,*) 'stack_size', stack_size
      Do j = 1, stack_size
         call get_stack(j, PID, p_n, v_n, point_n, time_n, n_reactionID)
c	   write(*,*) j, ' : PID', PID, ' : ', v_n
         if(PID .eq. PID_neutron) then
		n_hit = neutron_Travel(point_n, v_n, p_n, time_n, Dbl_Arm_Hit, Chrg_Hit)
		if ( n_hit .eq. Will_Hit ) then 
c ...    		save neutron info
			BSptr = BSptr + 1
c	write(*,*) time_n
			BS(BSptr, 1) = time_n
			BS(BSptr, 2) = p_n
			BSp(BSptr, 1) = point_n(1)
			BSp(BSptr, 2) = point_n(2)
			BSp(BSptr, 3) = point_n(3)
			BSv(BSptr, 1) = v_n(1)
			BSv(BSptr, 2) = v_n(2)
			BSv(BSptr, 3) = v_n(3)
			iBS(BSptr) = n_reactionID
			LBS(BSptr, 1) = Dbl_Arm_Hit
			LBS(BSptr, 2) = Chrg_Hit
	      EndIf
         else if(PID .eq. PID_pi0) then
		if ( rn() .lt. 0.3 ) then
		   n_hit = gamma_Travel(point_n, v_n, p_n, time_n)
		   if( n_hit .eq. Will_Hit ) then 
c ...    		save neutron info
			BSptr = BSptr + 1
c	write(*,*) time_n
			BS(BSptr, 1) = time_n
			BS(BSptr, 2) = p_n
			BSp(BSptr, 1) = point_n(1)
			BSp(BSptr, 2) = point_n(2)
			BSp(BSptr, 3) = point_n(3)
			BSv(BSptr, 1) = v_n(1)
			BSv(BSptr, 2) = v_n(2)
			BSv(BSptr, 3) = v_n(3)
			iBS(BSptr) = n_reactionID
			LBS(BSptr, 1) = .false.
			LBS(BSptr, 2) = .false.
	         EndIf
	      EndIf
	   EndIf
	EndDo
c ... simulate accidental neutron
	if(rn() .lt. CBG_level/2.) then
		call sphrrn(v_n)
		point_n(1) = 215.
		point_n(2) = 150.*(rn() -0.5)
		point_n(3) = 160.*(rn() -0.5)
		if(rn() .lt. 0.5) point_n(1) = - point_n(1)
		time_n = 100.*rn()
		p_n = 800.
		if ( n_hit .eq. Will_Hit ) then 
c ...    		save neutron info
			BSptr = BSptr + 1
			BS(BSptr, 1) = time_n
			BS(BSptr, 2) = p_n
			BSp(BSptr, 1) = point_n(1)
			BSp(BSptr, 2) = point_n(2)
			BSp(BSptr, 3) = point_n(3)
			BSv(BSptr, 1) = v_n(1)
			BSv(BSptr, 2) = v_n(2)
			BSv(BSptr, 3) = v_n(3)
			iBS(BSptr) = CBG
			LBS(BSptr, 1) = .false.
			LBS(BSptr, 2) = .false.
	      EndIf
	   EndIf
c check whether Neutron counters are fired
	if (BSptr .eq. 0) return
	sel4 = sel4 + 1
c	write(*,*) 'sel4', sel1, sel2, sel3, sel4 

	Trigger = .true.
	return
	end





	integer function neutron_travel(point, vector, p, time, Dbl_Arm_Hit, Chrg_Hit)
	implicit NONE
c input
	real point(3), vector(3), p, time
c output
	logical Dbl_Arm_Hit, Chrg_Hit
c common
	integer n_start, n_end
	common /ncount/ n_start, n_end
	integer ncv_start, ncv_end
	common /ncv/ ncv_start, ncv_end
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c local
	integer j, k, hit, PID, PIDc
	real length, cbeta, M_n / 939.56563/
	real pnt_lcl(3), v_lcl(3), p_lcl, t_lcl, dE, dL
	real point_c(3), v_c(3), p_c, time_c
	integer Will_Hit /-1/
c external
	integer BOXmap
c begin
	Dbl_Arm_Hit = .false.
	Chrg_Hit = .false.
      Do j = n_start, n_end
	   neutron_travel = BOXmap(j,point,vector,length)
         if(neutron_travel .eq. Will_Hit) then
            Do k = 1, 3
		   point(k) = point(k) + length * vector(k)
	      EndDo
		cbeta = 29.9792458 * p / sqrt(M_n**2 + p**2)
		time = time + length / cbeta
		if(j .eq. n_start) then
         	   call object_information(ncv_end, hit, dE, dL, 
     &			pnt_lcl, v_lcl, p_lcl, t_lcl, PID)
		   if(hit .ge. 1) then 
		      if(abs(PID) .eq. PID_pion .or. PID .eq. PID_proton) then 
		 	   Dbl_Arm_Hit = .true.
		      endif
		   endif
         	   call object_information(ncv_start, hit, dE, dL, 
     &			point_c, v_c, p_c, time_c, PIDc)
		   if( hit .ne. 0 ) Chrg_Hit = .true.
		else if(j .eq. n_end) then
         	   call object_information(ncv_start, hit, dE, dL, 
     &			pnt_lcl, v_lcl, p_lcl, t_lcl, PID)
		   if(hit .eq. 1) then 
		      if(abs(PID) .eq. PID_pion .or. PID .eq. PID_proton) then 
		 	   Dbl_Arm_Hit = .true.
		      endif
		   endif
         	   call object_information(ncv_end, hit, dE, dL, 
     &			point_c, v_c, p_c, time_c, PIDc)
		   if( hit .ne. 0 ) Chrg_Hit = .true.
		endif
	      return
	   endif
	EndDo
	return
	end





	integer function gamma_Travel(point, vector, p, time)
	implicit NONE
c input
	real point(3), vector(3), p, time
c output
c common
	integer n_start, n_end
	common /ncount/ n_start, n_end
	integer ncv_start, ncv_end
	common /ncv/ ncv_start, ncv_end
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c local
	integer j, k
	real length, cbeta, M_n / 939.56563/
	integer Will_Hit /-1/
c external
	integer BOXmap
c begin
      Do j = n_start, n_end
	   gamma_Travel = BOXmap(j,point,vector,length)
         if(gamma_Travel .eq. Will_Hit) then
            Do k = 1, 3
		   point(k) = point(k) + length * vector(k)
	      EndDo
		cbeta = 29.9792458 
		time = time + length / cbeta
	      return
	   endif
	EndDo
	return
	end





	real function n_efficiency(p)
	implicit none
	real p, Tn, Kinetic_Energy
c mass and particle ID in this routine
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c begin
	Tn = Kinetic_Energy( M_n, p )
	   n_efficiency = (0.094 / (1. + exp(-(Tn-23.5)/2.))
     &	+ 0.050 / (1. + exp(-(Tn-42.5)/2.))
     &	+ 0.03 / (1. + exp(-(Tn-57.)/3.)) ) / 0.174
	return
	end



