      Real function rn( )
      Implicit None
c random number generator
      Integer i_seed
	common /seed/ i_seed
      Common /RNDLCDAT/ISEED
	integer iseed
	real SRNDTS
	logical first 
c data
	data first /.true./
c begin
	if(first) then
	   call rn_init
c	   write(*, *) 'i_seed      ', i_seed
	   call rndtsini(i_seed)
	   first = .false.
	endif
	i_seed = iseed
      rn = SRNDTS( )
      Return
      End


      subroutine rn_init
c random number generator. this is used to remove the spurious binding 
c effects on ADC channel (this is quantized in integer, you know!)
      Implicit None
c random number generator
      Integer i
      Integer i_seed
	common /seed/ i_seed
c data
	data i / 76572171 /
c
      i = i * 48828125
      If( i .LT. 0 ) i = ( i + 2147483647 ) + 1
	i_seed = i
      Return
      End




c Random Number Gen. Package by N.Itoh
c initialize the random number generation routine 
c tausworthe sequence
C        IR_{n} = IR_{n-IP} .xor. IR_{n-IQ} 
c the bit-width is given in irbit.
c the linear congruential sequence (lcs) is used to 
c initialize the generator. the ilcbitTH of each
c lcs-random number is used to prepare the initial 
c sequence. 
      Subroutine RNDTSINI(irseed)
      Implicit NONE
c Input
      Integer irseed
c Const
      Integer IP,IQ,IRBIT,ILCBIT
      Parameter(IP=250,IQ=103,IRBIT=31,ILCBIT=20)
c Common
      Common /RNDTSDAT/ir(IP),irq(IP),inext(IP),ipos
      Integer ir, irq, inext, ipos
c External
      Integer IRNDLC
c Local
      Integer i, j, imask, ilc
C INITIALIZE THE I-IQ POSITION
        Do i=1, IP
          irq(i)=i-IQ
          If(irq(i).lt.1)irq(i)=irq(i)+IP
        End do
c initialize the next position
        Do i=1,IP-1
          inext(i)=i+1
        End do
        inext(IP)=1
c initialize the random seed
        Call RNDLCINI(irseed)
        Do i=1,IP
          ir(i)=0
        End do
        imask=2**(ILCBIT-1)
        Do i=1,IRBIT
          Do j=1,IP
            ilc=IRNDLC()
            ilc=ilc/imask
            ilc=iand(ilc,1)
            ir(j)=ir(j)*2+ilc
          End do
        End do
C
        ipos=1
C
      Return
      End

c initialize the random number generation routine
c linear congruential sequence
C        IR_{n} = 5^{11} * IR_{n-1} ( mod. 2^{31} )
      Subroutine RNDLCINI(IRSEED)
      Common /RNDLCDAT/ISEED
      Integer iseed
      ISEED=IRSEED
      Return
      End

c random integer in [ 1,2^{irbit}-1 ] generation routine 
c tausworthe sequence
C        IR_{n} = IR_{n-IP} .xor. IR_{n-IQ} 
      Integer Function IRNDTS()
      Implicit NONE
c Const
      Integer IP
      Parameter(IP=250)
c Common
      Common /RNDTSDAT/ir(IP),irq(IP),inext(IP),ipos
      Integer ir, irq, inext, ipos
c generate the next number
        ir(ipos)=ir(ipos).xor.ir(irq(ipos))
        irndts=ir(ipos)
c set the next position
        ipos=inext(ipos)
      Return
      End

c random number in (0,1) generation routine 
c single precision
c tausworthe sequence
C        IR_{n} = IR_{n-IP} .xor. IR_{n-IQ} 
      Real*4 Function SRNDTS()
c Const
      Integer IP, IRBIT
      Real SCONST
      Parameter(IP=250,IRBIT=31)
      Parameter(SCONST=1.0/2.0**IRBIT)
c Common
      Common /RNDTSDAT/ir(IP),irq(IP),inext(IP),ipos
      Integer ir, irq, inext, ipos
c generate the next number
        ir(ipos)=ir(ipos).xor.ir(irq(ipos))
        srndts=float(ir(ipos))*sconst
c set the next position
        ipos=inext(ipos)
      Return
      End

      Subroutine drndtsc(v)
      Implicit None
      real*8 drndts
      real*8 v

      v = drndts()
      return
      end

      
c random number in (0,1) generation routine 
c double precision
c tausworthe sequence
C        IR_{n} = IR_{n-IP} .xor. IR_{n-IQ} 
      Real*8 function DRNDTS()
      Implicit NONE
c Const
      Integer IP, IRBIT
      Real*8 DCONST
      Parameter(IP=250,IRBIT=31)
      Parameter(DCONST=1.0D0/2.0D0**IRBIT)
c Common
      Common /RNDTSDAT/ir(IP),irq(IP),inext(IP),ipos
      Integer ir, irq, inext, ipos
c generate the next number
cc	write(*,*)ir(ipos),ir(irq(ipos)),'->',ir(ipos).xor.ir(irq(ipos))
        ir(ipos)=ir(ipos).xor.ir(irq(ipos))
        drndts=dfloat(ir(ipos))*dconst
c set the next position
        ipos=inext(ipos)
        Return
      End
c
c Random Number Gen. Package By N.Itoh
c
c random integer in [1,2^{31}-1] generation 
c linear congruential sequence
C        IR_{n} = 5^{11} * IR_{n-1} ( mod. 2^{31} )
      Integer Function IRNDLC()
      Implicit NONE
c Common
      Common /RNDLCDAT/iseed
      Integer iseed
        iseed=iseed*48828125
        If(iseed .le. 0)iseed=(iseed+2147483647)+1
        irndlc=iseed
      Return
      End

c random number in (0,1) generation 
c single precision version
c linear congruential sequence
C        IR_{n} = 5^{11} * IR_{n-1} ( mod. 2^{31} )
C        DRNDLC = IR_{n} / 2^{31}
      Real*4 Function SRNDLC()
      Implicit NONE
c const
      Real SCONST      
      Parameter(SCONST=1.0E0/2147483648.0E0)
c Common
      Common /RNDLCDAT/iseed
      Integer iseed
        iseed=iseed*48828125
        If(iseed .le. 0) iseed=(iseed+2147483647)+1
        srndlc=float(iseed) * sconst
      Return
      End

c random number in (0,1) generation 
c double precision version
c linear congruential sequence
C        IR_{n} = 5^{11} * IR_{n-1} ( mod. 2^{31} )
C        DRNDLC = IR_{n} / 2^{31}
      Real*8 Function DRNDLC()
      Implicit NONE
c Const
      Real*8 DCONST
      Parameter(DCONST=1.0D0/2147483648.0D0)
c Common
      Common /RNDLCDAT/iseed
      Integer iseed
        iseed=iseed*48828125
        If(iseed .le. 0) iseed=(iseed+2147483647)+1
        drndlc=dfloat(iseed) * dconst
      Return
      End

